//+------------------------------------------------------------------+
//|                                          iSWOL(SuperWaveOneLine) 
//|       
//|         
//|       
//|   -20121020    
//+------------------------------------------------------------------+
#property copyright "valenok2003@mail.ru"
#define NAME_EXPERT "iSWOL"
#define RELIZE "20121029"                        
//-------------------------------------------------------------------------------------------------
//----           extern -----------
extern bool 
   Alert_ON = false;       
extern bool 
   Sound_ON = false;  
string Name_Sound = "_siren.wav";        

color 
   ColorM1      = Red, 
   ColorM1_M5   = Orange,
   ColorM5_M15  = Yellow,
   ColorM15_M30 = Lime,
   ColorM30_H1  = SkyBlue,
   ColorH1_H4   = Blue,
   ColorH4_D1   = Violet,
   ColorD1_W1   = BlueViolet,
   ColorW1_MN1  = Brown;   
extern int 
   TF_Indicator = 0;
extern bool  
   SHOW_SIGNAL_LINE = true;
//-------------------------------------------------------------------------------------------------
//----         ---------------------------------
extern int 
   St_K=5,
   St_D=3,
   St_S=3,
   Method = MODE_SMA,
   Price_Field = 0;
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
int 
   K,D,S,z,
   Style_Main_Line = DRAW_LINE,
   Style_Signal_Line = STYLE_DOT;
string 
   Name_Window,
   ex_Name = NAME_EXPERT;
//+------------------------------------------------------------------+
#property indicator_separate_window

#property indicator_buffers 2
#property indicator_level1 80
#property indicator_level2 20
#property indicator_levelcolor Gray

#property indicator_minimum 0
#property indicator_maximum 100
//---- buffers
double Buff_0[],Buff_1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//--------------------------------------------------------------------
   if(TF_Indicator < Period() || TF_Indicator == 0) TF_Indicator = Period();
   if(!check_TF(TF_Indicator)){
      TF_Indicator = Period();
      Alert(ex_Name+" "+txt_TF(TF_Indicator)+":      ");
   }
   z = MathRound(TF_Indicator/Period());
   K = St_K*z;
   D = St_D*z;
   S = St_S*z;
//------------    -------------------------------------- 
//---- name for indicator window
   Name_Window = txt_TF(TF_Indicator)+" "+ ex_Name + "(K"+K+",D"+D+",S"+S+")";
   IndicatorShortName(Name_Window);
//--------------------------------------------------------------------
//---- indicators ----------------------------------------------------
   SetIndexBuffer(0,Buff_0); 
   SetIndexBuffer(1,Buff_1); 
   //     
   int Period_for_Color;
   if(TF_Indicator == PERIOD_M1) Period_for_Color = PERIOD_M1;
   if(TF_Indicator > PERIOD_M1  && TF_Indicator <= PERIOD_M5)  Period_for_Color = PERIOD_M5;
   if(TF_Indicator > PERIOD_M5  && TF_Indicator <= PERIOD_M15) Period_for_Color = PERIOD_M15;
   if(TF_Indicator > PERIOD_M15 && TF_Indicator <= PERIOD_M30) Period_for_Color = PERIOD_M30;
   if(TF_Indicator > PERIOD_M30 && TF_Indicator <= PERIOD_H1)  Period_for_Color = PERIOD_H1;
   if(TF_Indicator > PERIOD_H1  && TF_Indicator <= PERIOD_H4)  Period_for_Color = PERIOD_H4;
   if(TF_Indicator > PERIOD_H4  && TF_Indicator <= PERIOD_D1)  Period_for_Color = PERIOD_D1;
   if(TF_Indicator > PERIOD_D1  && TF_Indicator <= PERIOD_W1)  Period_for_Color = PERIOD_W1;
   if(TF_Indicator > PERIOD_W1) Period_for_Color = PERIOD_MN1;
   switch(Period_for_Color) {  
      case PERIOD_M1:
         SetIndexStyle(0,Style_Main_Line,  0,0,ColorM1);  SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorM1);  SetIndexLabel (1,"");
      break;
      case PERIOD_M5:
         SetIndexStyle(0,Style_Main_Line,  0,0,ColorM1_M5);  SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorM1_M5);  SetIndexLabel (1,"");
      break;
      case PERIOD_M15:
         SetIndexStyle(0,Style_Main_Line,0,0,ColorM5_M15);   SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorM5_M15); SetIndexLabel (1,"");
      break;
      case PERIOD_M30:
         SetIndexStyle(0,Style_Main_Line,0,0,ColorM15_M30);   SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorM15_M30); SetIndexLabel (1,"");
      break;
      case PERIOD_H1:
         SetIndexStyle(0,Style_Main_Line,0,0,ColorM30_H1);    SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorM30_H1);  SetIndexLabel (1,"");
      break;
      case PERIOD_H4:
         SetIndexStyle(0,Style_Main_Line,0,0,ColorH1_H4);    SetIndexLabel (0,"St"+txt_TF(TF_Indicator)); 
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorH1_H4);  SetIndexLabel (1,"");
      break;
      case PERIOD_D1:
         SetIndexStyle(0,Style_Main_Line,0,0,ColorH4_D1);    SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorH4_D1);  SetIndexLabel (1,"");
      break;
      case PERIOD_W1:
         SetIndexStyle(0,Style_Main_Line,0,0,ColorD1_W1);    SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorD1_W1);  SetIndexLabel (1,"");
      break;
      case PERIOD_MN1:
         SetIndexStyle(0,Style_Main_Line,0,0,ColorW1_MN1);    SetIndexLabel (0,"St"+txt_TF(TF_Indicator));
         SetIndexStyle(1,0,Style_Signal_Line,0,ColorW1_MN1);  SetIndexLabel (1,"");
      break;
      default: break;
   }
      if(!SHOW_SIGNAL_LINE)SetIndexStyle(1,DRAW_NONE);
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {  
   int   i,                           //  
         Counted_bars;                //    
//--------------------------------------------------------------------
//--------------------------------------------------------------------
   Counted_bars= IndicatorCounted();   //    
   i=Bars-Counted_bars-1;              //   
   while(i>=0) {                       //    
      Buff_0[i] = iStochastic(NULL,Period(),K,D,S,Method,Price_Field,MODE_MAIN,i);
      Buff_1[i] = iStochastic(NULL,Period(),K,D,S,Method,Price_Field,MODE_SIGNAL,i);
      i--;
   }
   static bool
      FLAG_UP = true,
      FLAG_DN = true;
   string Txt_Alert;      
   static int PreviosTime = 0;
   if(Time[0] != PreviosTime)   {
      PreviosTime = Time[0];
      if(FLAG_UP && Buff_0[0] > Buff_1[0])   {
         Txt_Alert = "UP " + txt_TF(TF_Indicator)+" "+Symbol();
         output_alert_or_sound(Txt_Alert, Name_Sound);
         FLAG_UP = false;
         FLAG_DN = true;
      }
      if(FLAG_DN && Buff_0[0] < Buff_1[0])   {
         Txt_Alert = "DN " + txt_TF(TF_Indicator)+" "+Symbol();
         output_alert_or_sound(Txt_Alert, Name_Sound);
         FLAG_UP = true;
         FLAG_DN = false;
      }
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                14.06.2011
//+------------------------------------------------------------------+
//| txt_TF()                   
//+------------------------------------------------------------------+
string txt_TF( int _TF)
{  string _Function = "txt_TF():";
   string _Txt_TF;
   switch(_TF) {
      case PERIOD_M1:  _Txt_TF = "M1";  break;
      case PERIOD_M5:  _Txt_TF = "M5";  break;
      case PERIOD_M15: _Txt_TF = "M15"; break;
      case PERIOD_M30: _Txt_TF = "M30"; break;
      case PERIOD_H1:  _Txt_TF = "H1";  break;
      case PERIOD_H4:  _Txt_TF = "H4";  break;
      case PERIOD_D1:  _Txt_TF = "D1";  break;
      case PERIOD_W1:  _Txt_TF = "W1";  break;
      case PERIOD_MN1: _Txt_TF = "MN1"; break;
      default:      _Txt_TF = "TF"+_TF; break;
   }
   return(_Txt_TF);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                04.11.2011
//+------------------------------------------------------------------+
//| check_TF()  
//+------------------------------------------------------------------+
bool check_TF(int _Period){
   string _Function = "check_TF():";
   bool _RET = true;
//-----------------
   if(MathMod(_Period,Period())!= 0) _RET = false;      
//-----------------
   return(_RET);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                29.10.2012
//+------------------------------------------------------------------+
//| output_alert_or_sound()  
//| :
//| -  
//| -    
//+------------------------------------------------------------------+
void output_alert_or_sound(string _Txt_Alert, string _Name_Sound) {
   string _Function = "output_alert():";
//-----------------   
   if(Alert_ON) {
      Alert(_Txt_Alert + " - " + ex_Name);
   }
   else {
      if(Sound_ON) PlaySound(_Name_Sound);
   }
//-----------------   
   return;
}
//+------------------------------------------------------------------+
//+-------


